/*                                                          */
/*   CLP.C by Andrew I. Reshin. Last modified 13.07.2000.   */
/*                                                          */


#include <windows.h>
#include <stdio.h>

void main(int argc,char **argv)
{
DWORD retlen,numout,maxout,size;
CONSOLE_SCREEN_BUFFER_INFO csbi;
LPSTR newbuf,buf,ptr;
HGLOBAL hdata,htmp;
HANDLE hout,hin;
UINT cbfmt;
BOOL isok;

if(argc<2)
 {
 printf("Usage: %s <I(nput)|O(utput)>[W(indows text)]",argv[0]);
 return;
 }

CharUpper(argv[1]);
cbfmt=(*(argv[1]+1)=='W')?CF_TEXT:CF_OEMTEXT;

/* Copy stdin to clipboard */
if(*(argv[1])=='I')
 {
 hin=GetStdHandle(STD_INPUT_HANDLE);
 if(hin==INVALID_HANDLE_VALUE) return;
 hdata=GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE,4096);
 if(!hdata) return;
 size=0;
 isok=FALSE;

 while(buf=(LPSTR)GlobalLock(hdata))
  {
  if(isok=!(ReadFile(hin,buf+size,4095,&retlen,0) && retlen)) break;
  GlobalUnlock(hdata);
  *(buf+size+retlen)=0;
  size+=retlen;
  htmp=GlobalReAlloc(hdata,size+4096,GMEM_MOVEABLE|GMEM_DDESHARE);
  if(!htmp) break;
  hdata=htmp;
  }

 if(!isok)
  {
  GlobalFree(hdata);
  return;
  }

 isok=FALSE;

 if(OpenClipboard(0))
  {
  GlobalUnlock(hdata);
  isok=EmptyClipboard() && SetClipboardData(cbfmt,hdata);
  CloseClipboard();
  }

 if(!isok) GlobalFree(hdata);
 }
else
/* Copy clipboard to stdout */
 {
 hout=GetStdHandle(STD_OUTPUT_HANDLE);
 if(hout==INVALID_HANDLE_VALUE) return;

 if(GetConsoleScreenBufferInfo(hout,&csbi))
  maxout=csbi.dwSize.X*csbi.dwSize.Y;
 else
  {
  if(GetLastError()!=ERROR_INVALID_HANDLE) return;
  maxout=0xFFFFFFFF;
  }

 newbuf=0;

 if(OpenClipboard(0))
  {
  if((hdata=GetClipboardData(cbfmt)) && (buf=(LPSTR)GlobalLock(hdata)))
   {
   if((size=lstrlen(buf)) && (newbuf=(LPSTR)GlobalAlloc(GMEM_FIXED,size+1)))
	lstrcpy(newbuf,buf);

   GlobalUnlock(hdata);
   }

  CloseClipboard();
  }

 if(newbuf)
  {
  for(ptr=newbuf; size; size-=numout, ptr+=numout)
   {
   numout=(size<maxout)?size:maxout;
   if(!(WriteFile(hout,ptr,numout,&retlen,0) && retlen==numout)) break;
   }

  GlobalFree(newbuf);
}}}